#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1600one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 1600"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire1600one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one16004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 


# -------------------------------------------------------------------------------------------------
# 1600
# -------------------------------------------------------------------------------------------------                                          
shot2one16004xi = {
                  1:'0x0y1599z',
                  2:'0x1059y1199z',
                  3:'0x48y1599z',
                  4:'1010x820y930z',
                  5:'1011x949y796z',
                  6:'1044x761y943z',
                  7:'1054x890y809z',
                  8:'105x1208y1043z',
                  9:'108x1029y1220z',
                  10:'1092x829y823z',
                  11:'124x1480y594z',
                  12:'146x1418y725z',
                  13:'15x174y1590z',
                  14:'160x1010y1230z',
                  15:'160x1311y902z',
                  16:'167x1190y1055z',
                  17:'17x27y1599z',
                  18:'1x16y1599z',
                  19:'1x32y1599z',
                  20:'201x1465y609z',
                  21:'210x988y1240z',
                  22:'219x1401y739z',
                  23:'227x1169y1067z',
                  24:'227x1292y915z',
                  25:'22x1339y875z',
                  26:'22x158y1592z',
                  27:'23x41y1599z',
                  28:'258x964y1250z',
                  29:'276x1447y624z',
                  30:'27x141y1593z',
                  31:'285x1145y1079z',
                  32:'28x57y1598z',
                  33:'291x1380y753z',
                  34:'292x1269y928z',
                  35:'304x937y1260z',
                  36:'31x123y1594z',
                  37:'31x73y1597z',
                  38:'33x106y1596z',
                  39:'33x90y1597z',
                  40:'342x1118y1091z',
                  41:'348x908y1270z',
                  42:'350x1424y638z',
                  43:'355x1243y941z',
                  44:'361x1356y768z',
                  45:'390x877y1279z',
                  46:'396x1089y1102z',
                  47:'417x1214y954z',
                  48:'422x1397y653z',
                  49:'429x1328y782z',
                  50:'42x1222y1031z',
                  51:'430x844y1289z',
                  52:'448x1056y1114z',
                  53:'467x809y1298z',
                  54:'476x1182y966z',
                  55:'47x1490y579z',
                  56:'492x1367y668z',
                  57:'495x1296y795z',
                  58:'498x1021y1125z',
                  59:'501x772y1308z',
                  60:'50x39y1598z',
                  61:'533x734y1317z',
                  62:'534x1146y979z',
                  63:'545x984y1137z',
                  64:'54x1045y1209z',
                  65:'559x1261y809z',
                  66:'561x1333y682z',
                  67:'563x695y1326z',
                  68:'588x1108y992z',
                  69:'589x655y1335z',
                  70:'590x944y1148z',
                  71:'60x52y1598z',
                  72:'613x613y1343z',
                  73:'620x1223y823z',
                  74:'627x1296y697z',
                  75:'632x903y1159z',
                  76:'635x571y1352z',
                  77:'640x1067y1004z',
                  78:'653x529y1361z',
                  79:'669x486y1369z',
                  80:'671x859y1170z',
                  81:'679x1181y837z',
                  82:'690x1024y1017z',
                  83:'690x1255y711z',
                  84:'69x66y1597z',
                  85:'707x814y1181z',
                  86:'72x1431y711z',
                  87:'736x1137y850z',
                  88:'736x978y1029z',
                  89:'741x767y1192z',
                  90:'751x1211y725z',
                  91:'76x81y1596z',
                  92:'771x719y1202z',
                  93:'780x930y1041z',
                  94:'789x1090y864z',
                  95:'799x670y1213z',
                  96:'7x191y1588z',
                  97:'809x1164y739z',
                  98:'820x880y1053z',
                  99:'823x620y1223z',
                  100:'82x97y1594z',
                  101:'840x1040y877z',
                  102:'844x569y1233z',
                  103:'858x829y1065z',
                  104:'865x1114y754z',
                  105:'86x114y1593z',
                  106:'887x988y891z',
                  107:'892x776y1077z',
                  108:'89x132y1592z',
                  109:'90x150y1590z',
                  110:'90x169y1588z',
                  111:'917x1062y768z',
                  112:'923x721y1089z',
                  113:'92x1327y888z',
                  114:'931x934y904z',
                  115:'93x199y1685z',
                  116:'950x666y1101z',
                  117:'966x1007y782z',
                  118:'972x878y917z',
                  119:'9x13y1599z'}
                         

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1600one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1600one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE160ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE160ONE4XI -  QUEUE2ONE: ", queue2one)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE160ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE160ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE160ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE16004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one16004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE160ONE4XI - SUCCEEDED TO PUT SHOT2ONE16004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE16004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE160ONE4XI *** FAILED TO PUT SHOT2ONE16004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE160ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one16004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one16004xi</nack2put4xi>" 
                  
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
   
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE160ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one16004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE160ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE160ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1600one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
